function EventEmitter() {
    'use strict';
    var self = this;
    self.callbacks = {};
}

EventEmitter.prototype.on = function(type, callback) {
    var self = this;

    if (!(type in self.callbacks)) {
        self.callbacks[type] = [];
    }
    self.callbacks[type].push(callback);
};

EventEmitter.prototype.emit = function(type) {
    var self = this;
    var _type = type || 'all';

    if (_type in self.callbacks) {
        Array.prototype.shift.apply(arguments);
        var args = arguments;
        self.callbacks[_type].forEach(function(callback) {
            callback.apply(self, args);
        });
    }
};

EventEmitter.prototype.clearCallbacks = function(type) {
    var self = this;

    if (type) {
        self.callbacks[type] = [];
    } else {
        self.callbacks = {};
    }
};